@echo off
setlocal EnableDelayedExpansion

::*************************************
::OS Language
::*************************************
	echo ********************************
	echo ***LIST OF SUPPORTED LANGUAGE***
	echo ********************************
	echo 1 - English
	echo 2 - Francais
	echo ********************************
	
	set /P OS_LANGUAGE=Please select the operating system language. / SVP saisir la langue du systeme d'exploitation : 

::*************************************
::User inputs
::*************************************
	if %OS_LANGUAGE% == 1 (	
		set /P OMNIMED_LOGIN=Enter the Omnimed user login : 
	) else (
		set /P OMNIMED_LOGIN=Saisir le login de l'utilisateur pour Omnimed : 
	)

::*************************************
::Create Folders
::*************************************
	mkdir "C:\Scans"
	mkdir "C:\Scans\PDF-%OMNIMED_LOGIN%"
	mkdir "C:\Scans\PDF-%OMNIMED_LOGIN%\Archive"
	mkdir "C:\Scans\PDF-%OMNIMED_LOGIN%\Xfer"
	icacls "C:\Scans" /grant Everyone:F	
	
::*************************************
::Create Profiles
::*************************************	
	
	set SCANNER_MODEL_LIST[0]=fi-5110C 
	set SCANNER_MODEL_LIST[1]=fi-6130Z 
	set SCANNER_MODEL_LIST[2]=fi-6140Z
	set SCANNER_MODEL_LIST[3]=fi-6230Z
	set SCANNER_MODEL_LIST[4]=fi-6240Z
	set SCANNER_MODEL_LIST[5]=fi-7160
	set SCANNER_MODEL_LIST[6]=fi-7180
	set SCANNER_MODEL_LIST[7]=fi-7260
	set SCANNER_MODEL_LIST[8]=fi-7280
	
	echo *******************************
	echo ***LIST OF SUPPORTED SCANNER***
	echo *******************************
	for /L %%i in (0,1,8) do call echo %%i - !SCANNER_MODEL_LIST[%%i]!
	echo *******************************
		
	if %OS_LANGUAGE% == 1 (	
		set /P SCANNER_MODEL_ID=Enter the scanner model : 
	) else (
		set /P SCANNER_MODEL_ID=Choisir le modele du numeriseur :  
	)
	
	::Identify the scanner family
	if %SCANNER_MODEL_ID% geq 0 (
		if %SCANNER_MODEL_ID% leq 8 (
			set SCANNER_MODEL=!SCANNER_MODEL_LIST[%SCANNER_MODEL_ID%]!
			if %SCANNER_MODEL_ID% == 0 (
				set SCANNER_FAMILY=5xxx
			) else if %SCANNER_MODEL_ID% geq 5 (
				set SCANNER_FAMILY=7xxx
			) else (
				set SCANNER_FAMILY=6xxx
			)
		) else (
			echo Unrecognized Scanner Model.
			Exit /B
		)
	) else (
		echo Unrecognized Scanner Model.
		Exit /B
	)
	
	:: Copy the template folder for the proper scanner model.
	if %SCANNER_FAMILY% == 5xxx (
		robocopy Template_fi-5110C ScanningProfiles
	) else if %SCANNER_FAMILY% == 6xxx (
		robocopy Template_fi-6xxx ScanningProfiles
	) else if %SCANNER_FAMILY% == 7xxx (
		robocopy Template_fi-7xxx ScanningProfiles
	) else (
		echo Unrecognized Scanner Model.
		Exit /B
	)

::*************************************
::Adapt profile files to local user
::*************************************
	::Remove spaces in the USERNAME
	set USERNAME_STR=%USERNAME: =_%
	
	::*************************************
	::ExportInfo.ini
	::*************************************
	if %OS_LANGUAGE% == 1 (	
		cscript ReplaceInFile.vbs "ScanningProfiles\ExportInfo.ini" "UPDATE_LANGID" "09"
	) else (
		cscript ReplaceInFile.vbs "ScanningProfiles\ExportInfo.ini" "UPDATE_LANGID" "0c"
	)
	
	::*************************************
	::ScandAllPro.ini
	::*************************************
	::Nothing to do here !
	
	::*************************************
	::Settings.ini
	::*************************************
	::Nothing to do here !	
	
	::*************************************
	::ScandAllRegistry.ini
	::*************************************
	cscript ReplaceInFile.vbs "ScanningProfiles\ScandAllRegistry.ini" "UPDATE_USERNAME" "%USERNAME%"
	cscript ReplaceInFile.vbs "ScanningProfiles\ScandAllRegistry.ini" "UPDATE_LOGIN" "%OMNIMED_LOGIN%"
	cscript ReplaceInFile.vbs "ScanningProfiles\ScandAllRegistry.ini" "UPDATE_SCANNER_MODEL" "%SCANNER_MODEL%"
	::TODO : SaveFolder
	::TODO : LastSettingProfileName
	::TODO : ScanDriverName

	::*************************************
	::Black.dsi 
	::*************************************
	cscript ReplaceInFile.vbs "ScanningProfiles\Black.dsi" "UPDATE_USERNAME" "%USERNAME%"
	cscript ReplaceInFile.vbs "ScanningProfiles\Black.dsi" "UPDATE_SCANNER_MODEL" "%SCANNER_MODEL%"
	move ".\ScanningProfiles\Black.dsi" "ScanningProfiles\%OMNIMED_LOGIN%-Black.dsi"

	::*************************************
	::Black.ini
	::*************************************
	cscript ReplaceInFile.vbs "ScanningProfiles\Black.ini" "UPDATE_USERNAME_STR" "%USERNAME_STR%"
	cscript ReplaceInFile.vbs "ScanningProfiles\Black.ini" "UPDATE_LOGIN" "%OMNIMED_LOGIN%"
	cscript ReplaceInFile.vbs "ScanningProfiles\Black.ini" "UPDATE_SCANNER_MODEL" "%SCANNER_MODEL%"
	if %OS_LANGUAGE% == 1 (	
		cscript ReplaceInFile.vbs "ScanningProfiles\Black.ini" "UPDATE_USESCANNERSETTINGS" "Use Detail Scanner Settings"
	) else (
		cscript ReplaceInFile.vbs "ScanningProfiles\Black.ini" "UPDATE_USESCANNERSETTINGS" "Utiliser la configuration détaillée du scanneur"
	)
	::TODO : DRIVERNAME
	move "ScanningProfiles\Black.ini" "ScanningProfiles\%OMNIMED_LOGIN%-Black.ini"
	
	::*************************************
	::Color.dsi 
	::*************************************
	cscript ReplaceInFile.vbs "ScanningProfiles\Color.dsi" "UPDATE_USERNAME" "%USERNAME%"
	cscript ReplaceInFile.vbs "ScanningProfiles\Color.dsi" "UPDATE_SCANNER_MODEL" "%SCANNER_MODEL%"
	move ".\ScanningProfiles\Color.dsi" "ScanningProfiles\%OMNIMED_LOGIN%-Color.dsi"
	
	::*************************************
	::Color.ini
	::*************************************
	cscript ReplaceInFile.vbs "ScanningProfiles\Color.ini" "UPDATE_USERNAME_STR" "%USERNAME_STR%"
	cscript ReplaceInFile.vbs "ScanningProfiles\Color.ini" "UPDATE_LOGIN" "%OMNIMED_LOGIN%"
	cscript ReplaceInFile.vbs "ScanningProfiles\Color.ini" "UPDATE_SCANNER_MODEL" "%SCANNER_MODEL%"
	if %OS_LANGUAGE% == 1 (	
		cscript ReplaceInFile.vbs "ScanningProfiles\Color.ini" "UPDATE_USESCANNERSETTINGS" "Use Detail Scanner Settings"
	) else (
		cscript ReplaceInFile.vbs "ScanningProfiles\Color.ini" "UPDATE_USESCANNERSETTINGS" "Utiliser la configuration détaillée du scanneur"
	)
	::TODO : DRIVERNAME
	move "ScanningProfiles\Color.ini" "ScanningProfiles\%OMNIMED_LOGIN%-Color.ini"

::*************************************
::Make public_profiles.cab
::*************************************
	cscript ReplaceInFile.vbs "ScanningProfiles\PublicProfiles.ddf" "UPDATE_LOGIN" "%OMNIMED_LOGIN%"
	makecab /F ScanningProfiles\publicProfiles.ddf

::*************************************
::make User_Profile.cab
::*************************************
	cscript ReplaceInFile.vbs "ScanningProfiles\ScanningProfiles.ddf" "UPDATE_LOGIN" "%OMNIMED_LOGIN%"
	makecab /F ScanningProfiles\scanningProfiles.ddf
	
::*************************************
:: Move User_Profile.cab
::*************************************
	move "%OMNIMED_LOGIN%_Profiles.cab" "C:\Scans\"
	
::*************************************
:: Move the files needed for the transfer.
::*************************************
	copy "xfer.vbs" "C:\Scans\xfer_%OMNIMED_LOGIN%.vbs"
	cscript ReplaceInFile.vbs "C:\Scans\xfer_%OMNIMED_LOGIN%.vbs" "UPDATE_LOGIN" "%OMNIMED_LOGIN%"
	copy "xfer.cmd" "C:\Scans\xfer_%OMNIMED_LOGIN%.cmd"
	cscript ReplaceInFile.vbs "C:\Scans\xfer_%OMNIMED_LOGIN%.cmd" "UPDATE_LOGIN" "%OMNIMED_LOGIN%"
	copy "xferMove.cmd" "C:\Scans\xfer_%OMNIMED_LOGIN%_move.cmd"
	cscript ReplaceInFile.vbs "C:\Scans\xfer_%OMNIMED_LOGIN%_move.cmd" "UPDATE_LOGIN" "%OMNIMED_LOGIN%"
	
::*************************************
:: Create the schedule task
::*************************************
	schtasks /Create /SC DAILY /TN "SFTP-%OMNIMED_LOGIN%" /TR "wscript C:\Scans\xfer_%OMNIMED_LOGIN%.vbs" /ST 06:00 /DU 17:00 /RI 1
	
::*************************************
:: Clean up
::*************************************
	del setup.inf
	del setup.rpt